#
# Crystal Chips BootManager Host driver script. v1.2
#

KEEP

SET "TITLE" "PC Host"

IF EQU "$BM.CNF_LANGUAGE$" "1"
    # Spanish
    SET "DEV_DESC" "PC Host via PS2link"
ELSEIF EQU "$BM.CNF_LANGUAGE$" "2"
    # French
    SET "DEV_DESC" "PC Host via PS2link"
ELSEIF EQU "$BM.CNF_LANGUAGE$" "3"
    # German
    SET "DEV_DESC" "PC Host ber PS2link"
ELSEIF EQU "$BM.CNF_LANGUAGE$" "4"
    # Italian
    SET "DEV_DESC" "PC Host via PS2link"
ELSE
    # Default to english
    SET "DEV_DESC" "PC Host via PS2link"
ENDIF

# Do not change this.
GOTO "$ARG1$"
RETURN "-1"

:QUERY
    ADDWIDGET "CALL" "$TITLE$" "$DEV_DESC$" $ARG2$ "$ARG0$" "$ARG3$" "$ARG4$" "$ARG5$"
    RETURN "0"

:IF_QUERY
    IF EXISTS "host:/"
        ADDWIDGET "CALL" "$TITLE$" "$DEV_DESC$" $ARG2$ "host" "$ARG3$" "$ARG4$" "$ARG5$"
    ENDIF
    RETURN "0"

:CHECK_PRESENT
    RETURN 0

    IF EXISTS "host:/"
        IF NEQ "$BM.HOST_PRESENT$" "1"
            LOADEXEC "PBAT" "$BM.SCRIPTS$/BMCONT.PBT" "CHECK" "host"
            SET "BM.HOST_PRESENT" "1"
        ENDIF
    ELSEIF EQU "$BM.HOST_PRESENT$" "1"
        SET "BM.HOST_PRESENT" "0"
    ENDIF
    RETURN 0

:CHECK
    # LoadExec on host is not possible at this time so check doesn't need to do anything.
    RETURN 0

:INSTALL
    IF FAIL COPY "$PWD$" "$ARG2$/HOST"
        MESSAGE "Failed installing $TITLE$!"
       RRM "$ARG2$/HOST"
        RETURN -1
    ENDIF
    EXIT 0
:REMOVE
    RRM "$PWD$"
    EXIT "0"

:LOAD
    RETURN 0

:LOADEXEC
    # LoadExec on host is not possible at this time.
    RETURN "0"
